REM $INCLUDE: 'vbdos.bi'
' Wenn sie dieses Programm in VBDOS verwenden wollen:
' 1. QLB erzeugen: LINK /Q COPYDATA.OBJ+VBDOS.LIB,,,VBDOSQLB;
' 2. VBDOS mit /Es aufrufen: VBDOS /Es /L COPYDATA
' (CopyData.OBJ ist auf Diskette mitgeliefert)

DECLARE SUB CopyData (BYVAL i%, BYVAL l%, BYVAL k%, BYVAL n%, BYVAL m%)
DECLARE SUB EMSFreigeben (Handle AS INTEGER)
DECLARE SUB EMSLaden (Handle AS INTEGER, Segment AS INTEGER, Offset AS INTEGER, Laenge AS LONG)
DECLARE FUNCTION EMSSpeichern (Segment AS INTEGER, Offset AS INTEGER, Laenge AS LONG) AS INTEGER
DECLARE FUNCTION EMSFrei () AS INTEGER
DECLARE FUNCTION EMSGeladen () AS INTEGER
DECLARE FUNCTION EMSSegment () AS INTEGER
DECLARE FUNCTION InitEMS () AS INTEGER

' Die Fehlernummer, die alle Prozeduren/Funktionen
' erzeugen, wenn sie vom EMS-Treiber einen Fehler gemeldet bekommen
CONST EMSError = 8000

' Beispielprogramm zur Nutzung der EMS-Routinen
' Lschen Sie diese Zeilen, wenn Sie hieraus eine
' Library erstellen mchten!

	IF NOT EMSGeladen THEN PRINT "Kein EMS.": END

	PRINT "Sie haben"; EMSFrei; "KB EMS frei."

	DIM Array(1 TO 100) AS INTEGER
	FOR i% = 1 TO 100: Array(i%) = i%: NEXT

	PRINT "Das Array enthlt die Elemente"; Array(1); "-"; Array(100)
	PRINT "Es wird im EMS gespeichert."
	' Gre des Arrays ist 200 (100 Elemente  2 Byte)
	' Verschwendung, da sofort 16 KB belegt werden!
	Handle% = EMSSpeichern(VARSEG(Array(1)), VARPTR(Array(1)), 200)

	PRINT "Das Handle ist"; Handle%
	PRINT "Jetzt sind noch "; EMSFrei; "KB EMS frei."
	PRINT "Das Array wird gelscht."
	ERASE Array
	PRINT "Es enthlt jetzt die Elemente"; Array(1); "-"; Array(100)

	PRINT "Das Array wird aus dem EMS geladen."
	EMSLaden Handle%, VARSEG(Array(1)), VARPTR(Array(1)), 200
	PRINT "Es enthlt jetzt die Elemente"; Array(1); "-"; Array(100)

	PRINT "Der EMS wird freigegeben."
	EMSFreigeben Handle%
	PRINT "Jetzt sind wieder "; EMSFrei; "KB EMS frei."

' Gibt zurck, wieviel KB EMS frei sind
FUNCTION EMSFrei () AS INTEGER

	DIM Regs AS RegType
	Regs.ax = &H4200: INTERRUPT &H67, Regs, Regs
	IF Regs.ax \ 256 THEN ERROR EMSError
	EMSFrei = Regs.bx * 16
	
END FUNCTION

SUB EMSFreigeben (Handle AS INTEGER)

	DIM Regs AS RegType
	Regs.ax = &H4500: Regs.dx = Handle
	INTERRUPT &H67, Regs, Regs

END SUB

FUNCTION EMSGeladen () AS INTEGER

	DIM Regs AS RegTypeX, Vergleich AS STRING * 8

	' Durch diesen Aufruf wird das Segment ermittelt, in dem der EMM-Treiber sitzt,
	' wenn es ihn gibt:
	Regs.ax = &H3567: INTERRUPTX &H21, Regs, Regs

	' Die Bytes 10-17 aus dem Kopf des Treibers werden in "Vergleich" kopiert
	CopyData Regs.es, 10, VARSEG(Vergleich), VARPTR(Vergleich), 8

	' Wenn in Vergleich jetzt nicht "EMMXXXX0" steht, dann ist kein EMS-Treiber geladen
	EMSGeladen = Vergleich = "EMMXXXX0"

END FUNCTION

SUB EMSLaden (Handle AS INTEGER, Segment AS INTEGER, Offset AS INTEGER, Laenge AS LONG)

	DIM Regs AS RegType, AnzahlSeiten AS INTEGER
	DIM TempLaenge AS INTEGER, Seite AS INTEGER

	' Hier keine Kommentare, da fast alles wie in EMSSpeichern!

	AnzahlSeiten = (Laenge + 16383) \ 16384

	FOR Seite = 0 TO AnzahlSeiten - 1
		' Die logische Seite "Seite" auf die physische Seite 0 abbilden
		Regs.ax = &H4401: Regs.bx = Seite
		INTERRUPT &H67, Regs, Regs
		IF Regs.ax \ 256 THEN ERROR EMSError
		IF Seite < AnzahlSeiten OR Laenge MOD 16384 = 0 THEN TempLaenge = 16384 ELSE TempLaenge = Laenge MOD 16384

		CopyData EMSSegment, 0, Segment + Seite * &H400, Offset, TempLaenge
	NEXT

END SUB

FUNCTION EMSSegment () AS INTEGER

	STATIC LetzterWert AS INTEGER
	DIM Regs AS RegTypeX

	IF LetzterWert THEN
		' Bei erneutem Funktionsaufruf wird einfach der beim letzten Mal
		' ermittelte Wert bergeben. Einen erneuten Interruptaufruf sparen
		' wir uns.
		EMSSegment = LetzterWert
	ELSE
		Regs.ax = &H4100: INTERRUPTX &H67, Regs, Regs
		IF Regs.ax \ 256 THEN ERROR EMSError
		LetzterWert = Regs.bx: EMSSegment = Regs.bx
	END IF
		

END FUNCTION

FUNCTION EMSSpeichern (Segment AS INTEGER, Offset AS INTEGER, Laenge AS LONG) AS INTEGER

	DIM Regs AS RegType, AnzahlSeiten AS INTEGER
	DIM Handle AS INTEGER, Seite AS INTEGER, TempLaenge AS INTEGER

	' Ermitteln, wieviele EMS-Seiten gebraucht werden, um die Daten zu speichern;
	' dabei auf volle Seiten aufrunden.
	AnzahlSeiten = (Laenge + 16383) \ 16384

	' Seiten reservieren
	Regs.ax = &H4300: Regs.bx = AnzahlSeiten
	INTERRUPT &H67, Regs, Regs

	' Fehler?
	IF Regs.ax \ 256 THEN ERROR EMSError

	' Handle merken
	Handle = Regs.dx

	FOR Seite = 0 TO AnzahlSeiten - 1
		' Die logische Seite "Seite" auf die physische Seite 0 abbilden
		Regs.ax = &H4400: Regs.bx = Seite
		INTERRUPT &H67, Regs, Regs
		IF Regs.ax \ 256 THEN
			' Fehler aufgetreten. Hier reicht der einfache ERROR-Befehl nicht,
			' stattdessen mu der eben reservierte Speicher wieder freigegeben werden!
			Regs.ax = &H4500: Regs.dx = Handle
			INTERRUPT &H67, Regs, Regs
			ERROR EMSError
		END IF

		' Prfen, wieviele Byte noch kopiert werden mssen
		IF Seite < AnzahlSeiten OR Laenge MOD 16384 = 0 THEN TempLaenge = 16384 ELSE TempLaenge = Laenge MOD 16384
		' Byteanzahl in  den EMS kopieren (&h400 zur Segmentadresse hinzuzuaddieren hat
		' das gleiche Ergebnis wie die Addition von &h4000=16385 zur Offsetadresse)

		CopyData Segment + Seite * &H400, Offset, EMSSegment, 0, TempLaenge
	NEXT

	EMSSpeichern = Handle

END FUNCTION

