DECLARE FUNCTION ErsetzeInDatei (Datei AS STRING, Suchen AS STRING, Ersetzen AS STRING, GrossKlein AS INTEGER) AS INTEGER
DECLARE SUB VerzeichnisLesen (PathSpec AS STRING, FileName() AS STRING, Number AS INTEGER)
DECLARE FUNCTION extrahierepfad (DateiBezeichnung AS STRING) AS STRING
OPTION EXPLICIT
REM $INCLUDE: 'CONSTANT.BI'
CONST DateiZuGross = 1, Gefunden = 2, NichtGefunden = 3
CONST MaxDateien = 999

DIM DateiBezeichnung AS STRING, Suchen AS STRING, Ersetzen AS STRING
DIM AnzahlDateien AS INTEGER, GrossKlein AS INTEGER
DIM Zeichen AS STRING, DateiName(1 TO MaxDateien) AS STRING
DIM Zaehler AS INTEGER, Ersetzungen AS INTEGER, ZuGross AS INTEGER
DIM Pfadangabe AS STRING

PRINT "Suchen und Ersetzen in mehreren Dateien"
PRINT "======================================="

DO ' Hauptschleife (damit Programm mehrmals benutzt werden kann)
	PRINT
	DO ' Eingabeschleife (damit Benutzer Eingaben korrigieren kann)
		DO
			PRINT "Bitte geben Sie eine Dateibezeichnung an (* und ? erlaubt): ";
			LINE INPUT DateiBezeichnung
			VerzeichnisLesen DateiBezeichnung, DateiName(), AnzahlDateien
			IF AnzahlDateien = 0 THEN
				PRINT "Keine Dateien gefunden!"
			ELSE
				PRINT FORMAT$(AnzahlDateien); " Dateien passen."
				EXIT DO
			END IF
		LOOP

		DO
			PRINT "Bitte geben Sie den Suchtext ein: ";
			LINE INPUT Suchen
			IF LEN(Suchen) = 0 THEN
				PRINT "Suchtext darf nicht leer sein!"
			ELSE
				EXIT DO
			END IF
		LOOP

		PRINT "Bitte geben Sie den Ersatztext ein: ";
		LINE INPUT Ersetzen

		PRINT "Gro-/Kleinschreibung beachten (J/N)? ";
		DO: Zeichen = UCASE$(INPUT$(1)): LOOP UNTIL INSTR("JN", Zeichen)
		PRINT Zeichen: GrossKlein = (Zeichen = "J")

		PRINT "Alle Eingaben korrekt (J/N/A=Abbrechen): ";
		DO: Zeichen = UCASE$(INPUT$(1)): LOOP UNTIL INSTR("JNA", Zeichen)
		PRINT Zeichen: IF Zeichen = "A" THEN SYSTEM

	LOOP UNTIL Zeichen = "J" ' Ende Eingabeschleife

	Pfadangabe = extrahierepfad(DateiBezeichnung)

	FOR Zaehler = 1 TO AnzahlDateien
		SELECT CASE ErsetzeInDatei(Pfadangabe + DateiName(Zaehler), Suchen, Ersetzen, GrossKlein)
		CASE Gefunden
			Ersetzungen = Ersetzungen + 1
		CASE DateiZuGross
			ZuGross = ZuGross + 1
		END SELECT
	NEXT
	PRINT
	PRINT FORMAT$(AnzahlDateien); " Dateien geprft"
	PRINT FORMAT$(Ersetzungen); " Ersetzungen durchgefhrt"
	PRINT FORMAT$(ZuGross); " Dateien grer als 20KB"
	PRINT
	PRINT "Nochmal (J/N)? ";
	DO: Zeichen = UCASE$(INPUT$(1)): LOOP UNTIL INSTR("JN", Zeichen)
	PRINT Zeichen
LOOP UNTIL Zeichen = "N" ' Ende Hauptschleife

' ffnet die angegebene Datei, fhrt die Ersetzung aus und schreibt die Datei wieder, wenn eine Ersetzung stattgefunden hat
' Gibt als Funktionswert die Konstante "DateiZuGross" zurck, wenn Datei > 20 KB; ansonsten wird "Gefunden" oder
' "NichtGefunden" zurckgegeben.
FUNCTION ErsetzeInDatei (Datei AS STRING, Suchen AS STRING, Ersetzen AS STRING, GrossKlein AS INTEGER) AS INTEGER

	DIM DateiNummer AS INTEGER, FundStelle AS INTEGER
	DIM Puffer AS STRING, LetzterFund AS INTEGER
	DIM Ersetzung AS INTEGER
	DIM VergleichsPuffer AS STRING, VergleichsWert AS STRING

	DateiNummer = FREEFILE

	OPEN Datei FOR BINARY AS #DateiNummer
	IF LOF(DateiNummer) > 20000 THEN
		ErsetzeInDatei = DateiZuGross
	ELSE
		Puffer = SPACE$(LOF(DateiNummer))
		GET #DateiNummer, 1, Puffer
		IF GrossKlein THEN
			VergleichsPuffer = Puffer: VergleichsWert = Suchen
		ELSE
			VergleichsPuffer = UCASE$(Puffer): VergleichsWert = UCASE$(Suchen)
		END IF
		LetzterFund = 1
		DO
			FundStelle = INSTR(LetzterFund, VergleichsPuffer, VergleichsWert)
			IF FundStelle = 0 THEN EXIT DO
			Ersetzung = TRUE
			VergleichsPuffer = LEFT$(VergleichsPuffer, FundStelle - 1) + Ersetzen + MID$(VergleichsPuffer, FundStelle + LEN(VergleichsWert))
			Puffer = LEFT$(Puffer, FundStelle - 1) + Ersetzen + MID$(Puffer, FundStelle + LEN(VergleichsWert))
			LetzterFund = FundStelle + LEN(VergleichsWert)
		LOOP

		IF Ersetzung THEN
			CLOSE DateiNummer: KILL Datei
			OPEN Datei FOR BINARY AS DateiNummer
			PUT #DateiNummer, 1, Puffer
			ErsetzeInDatei = Gefunden
		ELSE
			ErsetzeInDatei = NichtGefunden
		END IF
	END IF
	CLOSE DateiNummer

END FUNCTION

FUNCTION extrahierepfad (DateiBezeichnung AS STRING) AS STRING

	DIM Zaehler AS INTEGER

	FOR Zaehler = LEN(DateiBezeichnung) TO 1 STEP -1   ' von hinten an nach : oder \ suchen
		SELECT CASE ASC(MID$(DateiBezeichnung, Zaehler, 1))
		CASE 92, 58                                     ' 92=\, 58=:
			extrahierepfad = LEFT$(DateiBezeichnung, Zaehler) ' wenn gefunden: alles bis hier ist Pfadangabe
			EXIT FUNCTION                                ' Funktion verlassen
		END SELECT
	NEXT
	extrahierepfad = ""                                ' Immer noch nix? Dann bleibt's leer

END FUNCTION

SUB VerzeichnisLesen (PathSpec AS STRING, FileName() AS STRING, Number AS INTEGER)

	FileName(1) = DIR$(PathSpec): Number = 1
	DO WHILE LEN(FileName(Number))
		Number = Number + 1
		FileName(Number) = DIR$
	LOOP
	Number = Number - 1

END SUB

