DECLARE FUNCTION TeilZahl (Zahl AS INTEGER, VonBit AS INTEGER, BisBit AS INTEGER) AS INTEGER
DECLARE FUNCTION DateiZeitCode (DateiName AS STRING) AS DOUBLE
DECLARE FUNCTION SignedInt (Zahl AS LONG) AS INTEGER
REM $INCLUDE: 'vbdos.bi'

FUNCTION DateiZeitCode (DateiName AS STRING) AS DOUBLE

	DIM Tag AS INTEGER, Monat AS INTEGER, Jahr AS INTEGER
	DIM Sek AS INTEGER, Min AS INTEGER, Stunde AS INTEGER
	DIM Register AS RegType, DateiNummer AS INTEGER


	DateiNummer = FREEFILE: OPEN DateiName FOR INPUT AS #DateiNummer

	Register.AX = &H5700: Register.BX = FILEATTR(DateiNummer, 2)
	INTERRUPT &H21, Register, Register: CLOSE DateiNummer

	Tag = TeilZahl(Register.DX, 1, 5): Monat = TeilZahl(Register.DX, 6, 9): Jahr = 1980 + TeilZahl(Register.DX, 10, 16)
	Sek = TeilZahl(Register.CX, 1, 5) * 2: Min = TeilZahl(Register.CX, 6, 11): Stunde = TeilZahl(Register.CX, 12, 16)
	DateiZeitCode = DATESERIAL(Jahr, Monat, Tag) + TIMESERIAL(Stunde, Min, Sek)

END FUNCTION

SUB SetzeDateiZeitCode (DateiName AS STRING, ZeitCode AS DOUBLE)

	DIM Tag AS INTEGER, Monat AS INTEGER, Jahr AS INTEGER
	DIM Sek AS INTEGER, Min AS INTEGER, Stunde AS INTEGER
	DIM Register AS RegType, DateiNummer AS INTEGER

	DateiNummer = FREEFILE: OPEN DateiName FOR INPUT AS #DateiNummer
	Register.CX = SignedInt(SECOND(ZeitCode) \ 2 + 32& * MINUTE(ZeitCode) + 2048& * HOUR(ZeitCode))
	Register.DX = SignedInt(DAY(ZeitCode) + 32& * MONTH(ZeitCode) + 512& * (YEAR(ZeitCode) - 1980))
	Register.AX = &H5701: Register.BX = FILEATTR(DateiNummer, 2)
	INTERRUPT &H21, Register, Register
	CLOSE DateiNummer

END SUB

FUNCTION SignedInt (Zahl AS LONG) AS INTEGER

	IF Zahl < 32768 THEN
		SignedInt = Zahl
	ELSE
		SignedInt = Zahl - 65536
	END IF

END FUNCTION

' Funktion TeilZahl ermittelt eine Zahl, die in einem
' bestimmten Bit-Bereich einer INTEGER-Zahl gespeichert
' ist. Gltige Bitnummern sind 1 bis 16. Die kleinste Zahl,
' die zurckgegeben wird, ist 0, die grte ist
' 2 ^ (BisBit - VonBit).
'
FUNCTION TeilZahl (Zahl AS INTEGER, VonBit AS INTEGER, BisBit AS INTEGER) AS INTEGER

	z% = 0
	FOR i = VonBit TO BisBit
		IF Zahl AND (2 ^ (i - 1)) THEN z% = z% + 2 ^ (i - VonBit)
	NEXT
	TeilZahl = z%

END FUNCTION

