DECLARE SUB Directory (DirName AS STRING, Maske AS STRING, FileName() AS STRING)
DECLARE SUB SetzeDateiZeitCode (DateiName AS STRING, ZeitCode AS DOUBLE)
DECLARE FUNCTION SignedInt (Zahl AS LONG) AS INTEGER
REM $DYNAMIC
DECLARE SUB GetDateFile (Monat AS INTEGER, Tag AS INTEGER, Jahr AS INTEGER)
DECLARE SUB GetTimeFile (Stunde AS INTEGER, Min AS INTEGER, Sekunde AS INTEGER)
DECLARE SUB FindFirstFile (Maske AS STRING, Attribut AS INTEGER, ErrorCode AS INTEGER)
DECLARE SUB FindNextFile (ErrorCode AS INTEGER)
DECLARE FUNCTION GetNameFile () AS STRING
DECLARE FUNCTION GetSizeFile () AS LONG
DECLARE FUNCTION GetTimeCode () AS DOUBLE
DECLARE FUNCTION TeilZahl (Zahl AS INTEGER, VonBit AS INTEGER, BisBit AS INTEGER) AS INTEGER
DECLARE FUNCTION GetAttrFile () AS INTEGER
REM $INCLUDE: 'vbdos.bi'

' FileName mu mit DIM 0 TO ... definiert sein
' (Neue Daten werden angehngt)
SUB Directory (DirName AS STRING, Maske AS STRING, FileName() AS STRING)

	DIM Fehler AS INTEGER, Anzahl AS INTEGER

	Anzahl = 0: Fehler = 0
	' Attribut = 39 sucht alle Dateien inkl. Hidden + System + Read-Only
	FindFirstFile DirName + Maske, 39, Fehler
	DO UNTIL Fehler
		Anzahl = Anzahl + 1
		IF Anzahl > UBOUND(FileName) THEN REDIM PRESERVE FileName(0 TO Anzahl + 50) AS STRING
		FileName(Anzahl) = GetNameFile
		FindNextFile Fehler
	LOOP

	REDIM PRESERVE FileName(0 TO Anzahl) AS STRING

END SUB

' Achtung: Fr Aufruf von DirectoryRek ist es wichtig, da
' 1. DirName + Maske zusammen eine gltige Dateibezeichnung
'    (wie bei DIR) ergeben
' 2. FileName mu mit DIM 0 TO 0 ("leer") dimensioniert sein
SUB DirectoryRek (DirName AS STRING, Maske AS STRING, FileName() AS STRING)

	DIM Fehler AS INTEGER, Anzahl AS INTEGER
	DIM Subdirectory(0 TO 0) AS STRING
	DIM NeuDirName AS STRING

	Fehler = 0: Anzahl = UBOUND(FileName)

	' Attribut = 39 sucht alle Dateien inkl. Hidden + System + Read-Only
	' und Subdirectories
	FindFirstFile DirName + Maske, 39, Fehler
	DO UNTIL Fehler
		Anzahl = Anzahl + 1
		IF Anzahl > UBOUND(FileName) THEN REDIM PRESERVE FileName(0 TO Anzahl + 50) AS STRING
		FileName(Anzahl) = DirName + GetNameFile
		FindNextFile Fehler
	LOOP

	REDIM PRESERVE FileName(0 TO Anzahl) AS STRING

	' jetzt Subdirectories suchen:
	Fehler = 0
	SubDirectoryZaehler = 0
	' Attribut = 16 sucht Directories
	FindFirstFile DirName + "*.*", 16, Fehler
	DO UNTIL Fehler
		' zustzliche Abfrage, da auch Dateien mit Attribut > 16 gefunden
		' werden:
		IF GetAttrFile AND 16 THEN
			' es ist ein Subdirectory gefunden worden.
			IF LEFT$(GetNameFile, 1) <> "." THEN
				REDIM PRESERVE Subdirectory(0 TO UBOUND(Subdirectory) + 1) AS STRING
				Subdirectory(UBOUND(Subdirectory)) = GetNameFile
			END IF
		END IF
		FindNextFile Fehler
	LOOP

	' alle Dateien sind in der Liste. Rekursiv werden die
	' Subdirectories abgearbeitet:

	FOR i% = 1 TO UBOUND(Subdirectory)
		NeuDirName = DirName + Subdirectory(i%) + "\"
		DirectoryRek NeuDirName, Maske, FileName()
	NEXT

END SUB

SUB FindFirstFile (Maske AS STRING, Attribut AS INTEGER, ErrorCode AS INTEGER)

	' Attribut = 0 sucht alle normalen Dateien; fr weitere Informationen
	' siehe Anhang E

	SHARED DTA AS STRING
	DIM Register AS RegTypeX
	DIM FileName AS STRING

	' Interrupt &H21, Funktion &H1A: DOS die Adresse der DTA (Disk Transfer
	' Area) mitteilen, in der es seine Datei-Informationen ablegen kann:
	DTA = SPACE$(128)
	Register.AX = &H1A * 256
	Register.ds = SSEG(DTA)
	Register.DX = SADD(DTA)
	INTERRUPTX &H21, Register, Register

	' Interrupt &H21, Funktion &H4E: Erste Datei suchen, die pat
	FileName = Maske + CHR$(0)
	Register.AX = &H4E * 256
	Register.CX = Attribut
	Register.ds = SSEG(FileName)
	Register.DX = SADD(FileName)
	INTERRUPTX &H21, Register, Register

	IF Register.flags AND 1 THEN
		' Fehler! (Keine Datei vorhanden oder Directory-Angabe falsch)
		ErrorCode = Register.AX
		EXIT SUB
	END IF
	ErrorCode = 0

END SUB

SUB FindNextFile (ErrorCode AS INTEGER)

	SHARED DTA AS STRING
	DIM Register AS RegTypeX

	' Interrupt &H21, Funktion &H1A: DOS die Adresse der DTA (Disk Transfer
	' Area) mitteilen, in der es seine Datei-Informationen ablegen kann:
	' (Mu dauernd aufgerufen werden, weil BASIC von Zeit zu Zeit den String
	' DTA im Speicher herumschiebt und dann die DOS bekannte Adresse nicht
	' mehr stimmt!)
	Register.AX = &H1A * 256
	Register.ds = SSEG(DTA)
	Register.DX = SADD(DTA)
	INTERRUPTX &H21, Register, Register

	' Interrupt &H21, Funktion &H4F: Nchste passende Datei suchen
	Register.AX = &H4F * 256
	INTERRUPTX &H21, Register, Register

	IF Register.flags AND 1 THEN
		' Fehler! (Keine Datei mehr gefunden)
		ErrorCode = Register.AX
	END IF

END SUB

FUNCTION GetAttrFile () AS INTEGER

	SHARED DTA AS STRING
	GetAttrFile = ASC(MID$(DTA, 22))

END FUNCTION

SUB GetDateFile (Monat AS INTEGER, Tag AS INTEGER, Jahr AS INTEGER)

	SHARED DTA AS STRING
	DIM Datum AS INTEGER

	' Datum ist in den Bytes 25-26 der DTA gespeichert
	Datum = CVI(MID$(DTA, 25, 2))

	' Tag in den Bits 1-5
	Tag = TeilZahl(Datum, 1, 5)
	' Monat in Bits 6-9
	Monat = TeilZahl(Datum, 6, 9)
	' Jahr relativ zu 1980 in Bits 10-16
	Jahr = 1980 + TeilZahl(Datum, 10, 16)

END SUB

FUNCTION GetNameFile () AS STRING

	SHARED DTA AS STRING
	GetNameFile = MID$(DTA, 31, INSTR(31, DTA, CHR$(0)) - 31)

END FUNCTION

FUNCTION GetSizeFile () AS LONG

	SHARED DTA AS STRING
	GetSizeFile& = ASC(MID$(DTA, 27)) + 256& * ASC(MID$(DTA, 28)) + 65536 * ASC(MID$(DTA, 29)) + 16777216 * ASC(MID$(DTA, 30))

END FUNCTION

FUNCTION GetTimeCode () AS DOUBLE

	GetTimeFile h%, m%, s%
	GetDateFile mm%, d%, y%
	GetTimeCode = TIMESERIAL(h%, m%, s%) + DATESERIAL(mm%, d%, y%)

END FUNCTION

SUB GetTimeFile (Stunde AS INTEGER, Min AS INTEGER, Sekunde AS INTEGER)

	SHARED DTA AS STRING
	DIM Zeit AS INTEGER

	' Zeitangabe steht auf Bytes 23-24 der DTA
	Zeit = CVI(MID$(DTA, 23, 2))

	' Sekunde ist in den ersten 5 Bit gespeichert,
	' allerdings in 2-Sekunden-Schritten
	Sekunde = TeilZahl(Zeit, 1, 5) * 2
	' Minute in den Bits 6-11
	Min = TeilZahl(Zeit, 6, 11)
	' Stunde in den Bits 12-16
	Stunde = TeilZahl(Zeit, 12, 16)

END SUB

SUB SetzeDateiZeitCode (DateiName AS STRING, ZeitCode AS DOUBLE)

	DIM Tag AS INTEGER, Monat AS INTEGER, Jahr AS INTEGER
	DIM Sek AS INTEGER, Min AS INTEGER, Stunde AS INTEGER
	DIM Register AS RegType, DateiNummer AS INTEGER

	DateiNummer = FREEFILE: OPEN DateiName FOR INPUT AS #DateiNummer
	Register.CX = SignedInt(SECOND(ZeitCode) \ 2 + 32& * MINUTE(ZeitCode) + 2048& * HOUR(ZeitCode))
	Register.DX = SignedInt(DAY(ZeitCode) + 32& * MONTH(ZeitCode) + 512& * (YEAR(ZeitCode) - 1980))
	Register.AX = &H5701: Register.BX = FILEATTR(DateiNummer, 2)
	INTERRUPT &H21, Register, Register
	CLOSE DateiNummer

END SUB

FUNCTION SignedInt (Zahl AS LONG) AS INTEGER

	IF Zahl < 32768 THEN
		SignedInt = Zahl
	ELSE
		SignedInt = Zahl - 65536
	END IF

END FUNCTION

' Funktion TeilZahl ermittelt eine Zahl, die in einem
' bestimmten Bit-Bereich einer INTEGER-Zahl gespeichert
' ist. Gltige Bitnummern sind 1 bis 16. Die kleinste Zahl,
' die zurckgegeben wird, ist 0, die grte ist
' 2 ^ (BisBit - VonBit).
'
FUNCTION TeilZahl (Zahl AS INTEGER, VonBit AS INTEGER, BisBit AS INTEGER) AS INTEGER

	z% = 0
	FOR i = VonBit TO BisBit
		IF Zahl AND (2 ^ (i - 1)) THEN z% = z% + 2 ^ (i - VonBit)
	NEXT
	TeilZahl = z%

END FUNCTION

