DECLARE FUNCTION Minimum (Zahl1 AS INTEGER, Zahl2 AS INTEGER, Zahl3 AS INTEGER) AS INTEGER
DECLARE FUNCTION Levenshtein (Wort1 AS STRING, Wort2 AS STRING) AS INTEGER

FUNCTION Levenshtein (Wort1 AS STRING, Wort2 AS STRING) AS INTEGER

   CONST GewichtErsetzen = 1, GewichtEinAusfuegen = 1

   DIM DistArray(0 TO LEN(Wort1), 0 TO LEN(Wort2)) AS INTEGER
   DIM Wort1Kuerzen AS INTEGER, Wort2Kuerzen AS INTEGER, BeideKuerzen AS INTEGER
   DIM i AS INTEGER, j AS INTEGER

   ' Wenn es sehr schnell gehen soll: Definieren Sie das DistArray als STATIC oder als globales
   ' Array, legen Sie eine maximale Stringlnge fest und fhren Sie die folgenden beiden Zeilen nur
   ' ein einziges mal aus anstatt bei jedem Aufruf!
   FOR i = 1 TO LEN(Wort1): DistArray(i, 0) = DistArray(i - 1, 0) + GewichtEinAusfuegen: NEXT
   FOR i = 1 TO LEN(Wort2): DistArray(0, i) = DistArray(0, i - 1) + GewichtEinAusfuegen: NEXT

   FOR i = 1 TO LEN(Wort1)
      FOR j = 1 TO LEN(Wort2)
         BeideKuerzen = DistArray(i - 1, j - 1) - GewichtErsetzen * (MID$(Wort1, i, 1) <> MID$(Wort2, j, 1))
         Wort1Kuerzen = DistArray(i - 1, j) + GewichtEinAusfuegen
         Wort2Kuerzen = DistArray(i, j - 1) + GewichtEinAusfuegen
         DistArray(i, j) = Minimum(BeideKuerzen, Wort1Kuerzen, Wort2Kuerzen)
      NEXT
   NEXT
   Levenshtein = DistArray(LEN(Wort1), LEN(Wort2))

END FUNCTION

FUNCTION Minimum (Zahl1 AS INTEGER, Zahl2 AS INTEGER, Zahl3 AS INTEGER) AS INTEGER

   IF Zahl2 < Zahl1 THEN
      IF Zahl2 < Zahl3 THEN Minimum = Zahl2 ELSE Minimum = Zahl3
   ELSE
      IF Zahl1 < Zahl3 THEN Minimum = Zahl1 ELSE Minimum = Zahl3
   END IF

END FUNCTION

