
SUB MischSort (FileName AS STRING)

   CONST False = 0, True = -1
   CONST ExtBuffer = 10
   CONST IntBuffer = 1024
   CONST TempFileCode = "MSORT.$"

   DIM AktuellesFile AS INTEGER
   DIM TempFile(1 TO ExtBuffer) AS INTEGER
   DIM InputFile AS INTEGER, OutputFile AS INTEGER
   DIM LaufZaehler AS INTEGER
   DIM LaufEnde(1 TO ExtBuffer) AS INTEGER
   DIM DateiEnde(1 TO ExtBuffer) AS INTEGER

   DIM Zeile AS STRING, LetzteZeile AS STRING
   DIM NaechsteZeile(1 TO ExtBuffer) AS STRING


   DO

      ' 1. Schritt: Der Inhalt des zu sortierenden Files wird auf
      ' alle temporren Files verteilt. Dabei wird immer ein ganzer
      ' Lauf kopiert.

      InputFile = FREEFILE
      OPEN FileName FOR INPUT AS #InputFile LEN = IntBuffer
      FOR i% = 1 TO ExtBuffer
         TempFile(i%) = FREEFILE
         OPEN TempFileCode + FORMAT$(i%) FOR OUTPUT AS #TempFile(i%) LEN = IntBuffer
      NEXT

      AktuellesFile = 1: LetzteZeile = ""
      DO UNTIL EOF(InputFile)
         LINE INPUT #InputFile, Zeile
         IF Zeile < LetzteZeile THEN

            ' Ein neuer Lauf beginnt. Whle eine andere temporre
            ' Datei:

            AktuellesFile = AktuellesFile + 1
            IF AktuellesFile > ExtBuffer THEN AktuellesFile = 1
         END IF
         LetzteZeile = Zeile
         PRINT #TempFile(AktuellesFile), Zeile
      LOOP

      ' 2. Schritt: Das Kopieren ist beendet; jetzt werden die
      ' temporren Dateien wieder zusammengemischt. Dabei wird stets
      ' das kleinste von allen "wartenden" Elementen ausgewhlt und
      ' in die Ergebnisdatei geschrieben. Es wird laufweise gemischt,
      ' das heit, der erste Lauf aus der ersten temporren Datei wird
      ' nur mit den ersten Lufen der anderen temporren Dateien (und mit
      ' keinem zweiten Lauf) gemischt. Deshalb werden Dateien, bei denen
      ' der aktuelle Lauf schon zu Ende gelesen ist, bei der Elementauswahl
      ' nicht bercksichtigt.

      CLOSE InputFile: OPEN FileName FOR OUTPUT AS #InputFile LEN = IntBuffer
      FOR i% = 1 TO ExtBuffer
         CLOSE TempFile(i%)
         OPEN TempFileCode + FORMAT$(i%) FOR INPUT AS #TempFile(i%) LEN = IntBuffer
      NEXT

      ' Das Feld NaechsteZeile() wird mit der ersten Zeile jeder Datei
      ' gefllt
      FOR i% = 1 TO ExtBuffer
         IF NOT EOF(TempFile(i%)) THEN
            LINE INPUT #TempFile(i%), NaechsteZeile(i%)
            LaufEnde(i%) = False
            DateiEnde(i%) = False
         ELSE
            LaufEnde(i%) = True
            DateiEnde(i%) = True
         END IF
      NEXT

      ' Auf geht's!
      LaufZaehler = 0: NeuLauf = False
      DO
         Kleinstes = 0
         DO
            FOR i% = 1 TO ExtBuffer
               IF NOT LaufEnde(i%) THEN
                  IF Kleinstes = 0 THEN
                     Kleinstes = i%
                  ELSEIF NaechsteZeile(Kleinstes) > NaechsteZeile(i%) THEN
                     Kleinstes = i%
                  END IF
               END IF
            NEXT
            IF Kleinstes = 0 THEN
               IF NOT NeuLauf THEN
                  ' Wenn kein kleinstes Element gefunden wird, weil alle
                  ' Lufe zu Ende sind, wird in jeder Datei der nchste
                  ' Lauf angebrochen. (Eine Datei, die schon vllig zu
                  ' Ende ist, weil sie vielleicht einen Lauf weniger
                  ' enthlt als die anderen, soll weiter ignoriert werden.)
                  FOR i% = 1 TO ExtBuffer
                     LaufEnde(i%) = DateiEnde(i%)
                  NEXT
                  NeuLauf = True
                  LaufZaehler = LaufZaehler + 1
               ELSE
                  ' Wenn unmittelbar nach einem Neuanfang (siehe obige
                  ' Bemerkung) noch immer kein kleinstes Element gefunden
                  ' wird, mu das daran liegen, da alle Dateien zu Ende
                  ' sind. Dann wird die Schleife verlassen, und das
                  ' Mischen ist beendet.
                  Kleinstes = -1
               END IF
            ELSE
               NeuLauf = False
            END IF
         LOOP WHILE Kleinstes = 0

         IF Kleinstes > 0 THEN
            LetzteZeile = NaechsteZeile(Kleinstes)
            PRINT #InputFile, LetzteZeile
            IF EOF(TempFile(Kleinstes)) THEN
               LaufEnde(Kleinstes) = True
               DateiEnde(Kleinstes) = True
            ELSE
               LINE INPUT #TempFile(Kleinstes), NaechsteZeile(Kleinstes)
               IF NaechsteZeile(Kleinstes) < LetzteZeile THEN
                  LaufEnde(Kleinstes) = True
               END IF
            END IF
         END IF
      LOOP UNTIL Kleinstes = -1

      CLOSE InputFile
      FOR i% = 1 TO ExtBuffer: CLOSE TempFile(i%): NEXT

      ' Ein Sortier- und ein Mischvorgang sind abgeschlossen.
      ' Beim Mischen wird gezhlt, wieviele Lufe gemischt wurden.
      ' In dem Augenblick, wo jede temporre Datei nur noch einen
      ' (oder gar keinen) Lauf enthielt, fand das letzte Mischen
      ' statt; wurde hingegen mehr als ein Lauf gemischt, mu nun
      ' von neuem verteilt werden.

   LOOP UNTIL LaufZaehler = 1

   ' Lschen der temporren Dateien
   FOR i% = 1 TO ExtBuffer
      KILL TempFileCode + FORMAT$(i%)
   NEXT

END SUB

