' RHELP-Projekt
' Anstze zu einer vernfntigen Hilfe-Funktion
'
' Bentigt wird eine TXT-Datei, die in Themen unterteilt ist.
' Ein Thema wird eingeleitet von einer Zeile, die mit einem Punkt,
' einem groen T, einem Leerzeichen und dem Themennamen beginnt,
' etwa so:
' .T Dies ist ein Thema
' Jedes Thema kann beliebige viele Stichworte enthalten, diese
' mssen wie folgt vermerkt sein:
' .S Stichwort
'
' Das Programm erzeugt aus dieser Datei eine Indexdate und kann
' dann Themen oder Stichworte suchen; dabei wird fr die Themen-
' und Stichwortliste im Speicher kein Platz bentigt.
' Der Aufruf luft z.Zt. ber die Befehlszeile, wobei
' RHELP Thema
' Hilfe zum Thema "Thema" anzeigt und
' RHELP *Stichwort
' Hilfe zum Thema "Stichwort".
' In der Main-Prozedur mssen die Dateinamen eingestellt
' werden. Auswahllisten fr Themen sind noch nicht vorgesehen.




DECLARE FUNCTION GroesseStimmt () AS INTEGER
DECLARE SUB Main ()
DECLARE SUB CreateIndexfile ()
DECLARE SUB QuickSort (Array() AS ANY, Anzahl AS INTEGER)

'$FORM MainForm

   TYPE TopType
      Text AS STRING * 56
      OrgNr AS INTEGER
      Laenge AS INTEGER
      Pos AS LONG
   END TYPE

   TYPE IndType
      Text AS STRING * 56
      Line AS INTEGER
      Topic AS INTEGER
   END TYPE

   COMMON SHARED HelpWidth AS INTEGER
   COMMON SHARED IndexFile AS STRING, HelpFile AS STRING

   Main

REM $DYNAMIC
' Diese Prozedur erzeugt aus der Datei namens HELPFILE
' eine neue Indexdatei (INDEXFILE).
'
SUB CreateIndexfile ()

   DIM Topic(1 TO 1) AS TopType, TopCount AS INTEGER
   DIM IndCount AS INTEGER, Zeile AS STRING, IntVar AS INTEGER
   DIM Longvar AS LONG, TopicOffset AS LONG, DateiLaenge AS LONG

   OPEN HelpFile FOR INPUT AS #1
   DO UNTIL EOF(1)
      OldPos = SEEK(1) - 1
      LINE INPUT #1, Zeile
      IF LEFT$(Zeile, 3) = ".T " THEN
         IF TopCount THEN Topic(TopCount).Laenge = OldPos - Topic(TopCount).Pos + 1
         TopCount = TopCount + 1
         REDIM PRESERVE Topic(1 TO TopCount) AS TopType
         Topic(TopCount).Text = MID$(Zeile, 4)
         Topic(TopCount).Pos = SEEK(1)
         Topic(TopCount).OrgNr = TopCount
      END IF
   LOOP
   IF TopCount THEN Topic(TopCount).Laenge = SEEK(1) - Topic(TopCount).Pos
   DateiLaenge = LOF(1)
   CLOSE 1

   QuickSort Topic(), TopCount

   DIM NumberConvert(1 TO TopCount) AS INTEGER

   OPEN IndexFile FOR BINARY AS #1
   Longvar = 9 + TopCount * LEN(Topic(1))
   PUT #1, , Longvar
   PUT #1, , DateiLaenge
   FOR i% = 1 TO TopCount
      NumberConvert(Topic(i%).OrgNr) = i%
      PUT #1, , Topic(i%)
   NEXT
   CLOSE 1: ERASE Topic: TopCount = 0

   OPEN HelpFile FOR INPUT AS #1
   DO UNTIL EOF(1)
      LINE INPUT #1, Zeile
      IF LEFT$(Zeile, 3) = ".T " THEN
         TopicOffset = SEEK(1)
         TopCount = TopCount + 1
      ELSEIF LEFT$(Zeile, 3) = ".S " THEN
         IndCount = IndCount + 1: TopicOffset = TopicOffset + LEN(Zeile) + 2
         REDIM PRESERVE Topic(1 TO IndCount) AS TopType
         Topic(IndCount).Text = MID$(Zeile, 4)
         Topic(IndCount).OrgNr = SEEK(1) - TopicOffset
         Topic(IndCount).Laenge = NumberConvert(TopCount)
      END IF
   LOOP
   CLOSE 1
   
   QuickSort Topic(), IndCount

   OPEN IndexFile FOR BINARY AS #1
   SEEK #1, Longvar
   FOR i% = 1 TO IndCount
      PUT #1, , Topic(i%).Text
      PUT #1, , Topic(i%).Laenge
      PUT #1, , Topic(i%).OrgNr
   NEXT
   CLOSE 1

END SUB

REM $STATIC
SUB Drucken_Click ()

   ON LOCAL ERROR RESUME NEXT
   Printer.PRINT Textfeld.Text
   IF ERR THEN
      MSGBOX "Drucker an LPT1: kann nicht" + CHR$(13) + CHR$(10) + "angesprochen werden!", 0, "Fehler"
   ELSE
      Printer.ENDDOC
   END IF

END SUB

FUNCTION GroesseStimmt () AS INTEGER

   DIM DateiLaenge1 AS LONG, DateiLaenge2 AS LONG

   OPEN HelpFile FOR INPUT AS #1
   DateiLaenge1 = LOF(1)
   CLOSE 1
   OPEN IndexFile FOR BINARY AS #1
   GET #1, 5, DateiLaenge2
   CLOSE 1
   GroesseStimmt = DateiLaenge1 = DateiLaenge2

END FUNCTION

SUB Main ()

   DIM HelpSetting AS STRING, HelpPath AS STRING
   ON LOCAL ERROR RESUME NEXT

   PRINT "Programm zur Anzeige von Hilfstexten"

   HelpWidth = 70 ' Breite des Fensters
   HelpFile = "HILFE.TXT"
   IndexFile = "HILFE.IDX" ' wird automatisch neu

   IF LEN(DIR$(IndexFile)) = 0 THEN
      PRINT "Die Datei "; IndexFile; " ist nicht vorhanden."
      PRINT "Bitte warten Sie; die Datei wird neu erzeugt."
      CreateIndexfile
   ELSEIF NOT GroesseStimmt THEN
      PRINT "Die Datei "; IndexFile; " pat nicht zur Datei "; HelpFile; "."
      PRINT "Bitte warten Sie; die Datei wird neu erzeugt."
      CreateIndexfile
   END IF

   IF ERR THEN
     PRINT "FEHLER:"
     PRINT ERROR$; " bei der Initialisierung."
     SYSTEM
   END IF

   MainForm.SHOW
   MainForm.Textfeld.SETFOCUS

   DO: LOOP WHILE DOEVENTS()

   CLS
   SYSTEM

END SUB

SUB QuickSort (Array() AS TopType, Anzahl AS INTEGER)

   CONST MaxMerk = 15   ' reicht zum Sortieren von
                        ' 2^15 Elementen

   DIM Links AS INTEGER, Rechts AS INTEGER
   DIM MerkAnzahl AS INTEGER, Vergleich AS STRING * 58
   DIM MerkL(1 TO MaxMerk) AS INTEGER
   DIM MerkR(1 TO MaxMerk) AS INTEGER

   MerkAnzahl = 1
   MerkL(1) = 1
   MerkR(1) = Anzahl

   DO
      Links = MerkL(MerkAnzahl): Rechts = MerkR(MerkAnzahl)
      MerkAnzahl = MerkAnzahl - 1
      DO
         i% = Links: j% = Rechts
         Vergleich = Array((Links + Rechts) \ 2).Text
         DO
            DO WHILE Array(i%).Text < Vergleich: i% = i% + 1: LOOP
            DO WHILE Vergleich < Array(j%).Text: j% = j% - 1: LOOP
            IF i% <= j% THEN
               SWAP Array(i%), Array(j%)
               i% = i% + 1: j% = j% - 1
            END IF
         LOOP UNTIL i% > j%
         IF j% - Links < Rechts - i% THEN
            IF i% < Rechts THEN
               MerkAnzahl = MerkAnzahl + 1
               MerkL(MerkAnzahl) = i%
               MerkR(MerkAnzahl) = Rechts
            END IF
            Rechts = j%
         ELSE
            IF Links < j% THEN
               MerkAnzahl = MerkAnzahl + 1
               MerkL(MerkAnzahl) = Links
               MerkR(MerkAnzahl) = j%
            END IF
            Links = i%
         END IF
      LOOP WHILE Links < Rechts
   LOOP UNTIL MerkAnzahl = 0

END SUB

SUB TextFeld_KeyPress (KeyAscii AS INTEGER)

   KeyAscii = 0

END SUB

