DECLARE FUNCTION FindProcName (Zeile AS STRING) AS STRING
DECLARE SUB GetInfo (Overlay AS INTEGER, Adresse AS STRING, Datei AS STRING, ZeileAbs AS INTEGER, Prozedur AS STRING, ZeileRel AS INTEGER, Zeile AS STRING, Correct AS INTEGER)
DECLARE SUB INC (Zahl AS LONG)
DECLARE FUNCTION OverlayText (Zahl AS INTEGER) AS STRING
DECLARE SUB PrintAktion (Zeile AS STRING, Ausgabe AS INTEGER)
DECLARE SUB Statistik ()
DECLARE FUNCTION XLTRIM (Text AS STRING) AS STRING
REM $DYNAMIC
OPTION EXPLICIT

CONST True = -1, False = 0

DIM Zeile AS STRING, CallOverlay AS INTEGER, Overlay AS INTEGER
DIM Address AS STRING * 4, CallAddress AS STRING * 4
DIM ProzedurZeile AS STRING, ProzedurName AS STRING, ModulName AS STRING
DIM ModulZeileNr AS INTEGER, ProzedurZeileNr AS INTEGER
DIM Position AS INTEGER, PresentZeile AS INTEGER, Text AS STRING
DIM ReturnZeile AS INTEGER, xReturn AS INTEGER

DIM SHARED MapFile AS STRING, TraceFile AS STRING
DIM Present AS INTEGER

TYPE CountType       ' Zhlt Overlay-Zugriffe
   Hit AS LONG
   FromDisk AS LONG
   FromEMS AS LONG
   FromXMS AS LONG
   ToDisk AS LONG
   ToEMS AS LONG
   ToXMS AS LONG
   DiscardEMSXMS AS LONG
END TYPE

DIM SHARED Count(1 TO 1) AS CountType

   CLS
   PRINT "TRACELST (c) Frederik Ramm"
   PRINT
   PRINT "Experimentalprogramm zur Auswertung des TRACE-Outputs"
   PRINT "Was tun mssen, um dieses Programm zu benutzen:"
   PRINT "- Die einzlenen .BAS- und .FRM-Module mit /zi oder /zd kompilieren und"
   PRINT "  mit einem geeigneten LINK-Befehl zu einem EXE-Programm verbinden."
   PRINT "  Dabei beim Linken die Library VBDTRACE.LIB und den Switch /LI angeben."
   PRINT "- Danach das EXE-Programm starten und intensiv benutzen."
   PRINT "- Dann TRACE > exename.TRC eingeben, wobei Sie fr exename den"
   PRINT "  Namen des EXE-Files einsetzen."
   PRINT
   PRINT "Dieses Programm tut folgendes:"
   PRINT "- Es liest die exename.TRC-Datei ein, die von TRACE erzeugt wurde."
   PRINT "- Aufgrund der in der exename.MAP-Datei, die beim Linken erzeugt wurde,"
   PRINT "  gespeicherten Informationen lokalisiert es die Zeilen in Ihren Modulen,"
   PRINT "  die Overlayx-Aufrufe verursachten."
   PRINT "- Es liest Ihre Quelltexte (mssen im aktuellen Verzeichnis stehen) ein,"
   PRINT "  um die zugehrigen Prozedurnaen und Zeilen zu ermitteln."
   PRINT
   PRINT "Geben Sie den Namen Ihrer EXE-Datei ein (ohne Extension), fr den"
   PRINT "zugelich eine .MAP- und eine .TRC-Datei existieren mssen:"
   LINE INPUT Text
   TraceFile = Text + ".TRC"
   MapFile = Text + ".MAP"
   IF DIR$(TraceFile) = "" OR DIR$(MapFile) = "" THEN
      PRINT ".MAP- oder .TRC-Datei fehlt."
      PRINT "Die .MAP-Datei erzeugen Sie, indem Sie beim Linken /LI angeben."
      PRINT "Die .TRC-Datei erzeugen Sie durch einen Aufruf von TRACE, nachdem Sie"
      PRINT "das mit VBDTRACE.LIB gelinkte Programm gestartet haben."
      END
   END IF
   PRINT
   PRINT "Sollen alle Overlayaufrufe ausgegeben werden oder nur die, die"
   PRINT "auf ein Overlay zugreifen, das nicht bereits geladen ist?"
   PRINT "A=Alle, U=nur ungeladene: ";
   LINE INPUT Text
   Present = UCASE$(LEFT$(Text, 1)) = "A"
   PRINT
   PRINT "Sollen auch die Rcksprnge aus Overlays in andere Overlays"
   PRINT "(RETURN-Zeilen in der TRACE-Ausgabe) angezeigt werden? ";
   LINE INPUT Text
   xReturn = UCASE$(LEFT$(Text, 1)) = "J"

   PRINT
   PRINT "Los geht's!"
   PRINT

   OPEN TraceFile FOR INPUT AS #1

   DO UNTIL EOF(1)
      LINE INPUT #1, Zeile
      IF LEFT$(Zeile, 1) = "(" THEN                   ' es ist eine Datenzeile
         PresentZeile = (INSTR(Zeile, "Present") > 0)
         IF (NOT PresentZeile) OR Present THEN
            ReturnZeile = INSTR(Zeile, "Return") > 0
            IF (NOT ReturnZeile) OR xReturn THEN
               Overlay = VAL("&H" + MID$(Zeile, 2))      ' Nummer des aufrufenden Overlays
               Address = UCASE$(MID$(Zeile, 13, 4))      ' Offset-Adresse hierin (Segmentadresse unwichtig)
               PRINT
               GetInfo Overlay, Address, ModulName, ModulZeileNr, ProzedurName, ProzedurZeileNr, ProzedurZeile, True
               IF ModulZeileNr = 0 THEN
                  IF LEN(ModulName) THEN                 ' Wenigstens das Modul ist bekannt
                     PRINT "VBDOS an Adresse "; Address; "h im Modul "; ModulName; " ("; OverlayText(Overlay); ")"
                  ELSE                                   ' auch das Modul ist nicht bekannt
                     PRINT "VBDOS an Adresse "; Address; "h im "; OverlayText(Overlay)
                  END IF
               ELSE                                      ' Sowohl Modul als auch betr. Zeile wurden gefunden
                  PRINT "Prozedur "; ProzedurName; " aus Modul "; ModulName; " ("; OverlayText(Overlay); "):"
                  PRINT "   "; XLTRIM$(ProzedurZeile); " ("; FORMAT$(ProzedurZeileNr); ")"
               END IF
               IF ReturnZeile THEN
                  PRINT "   ist Rcksprungadresse nach Beendigung einer Prozedur in anderem Overlay"
                  PRINT "   und verursacht daher folgende Aktion(en):"
               ELSE
                  PRINT "   verursacht durch einen Aufruf an:"
                  Position = INSTR(Zeile, "Call (")         ' darf nie 0 werden!
                  CallOverlay = VAL("&h" + MID$(Zeile, Position + 6))
                  CallAddress = UCASE$(MID$(Zeile, Position + 12))
                  GetInfo CallOverlay, CallAddress, ModulName, ModulZeileNr, ProzedurName, ProzedurZeileNr, ProzedurZeile, False
                  PRINT "   "; OverlayText(CallOverlay);
                  IF LEN(ModulName) THEN PRINT ", Modul "; ModulName;
                  IF ModulZeileNr = 0 THEN
                     PRINT ", VBDOS an Adresse "; CallAddress
                  ELSE
                     PRINT ", Prozedur "; ProzedurName
                  END IF
                  PRINT "   folgende Aktion(en):"
               END IF
               PrintAktion Zeile, True
            ELSE
               PrintAktion Zeile, False
            END IF
         ELSE
            PrintAktion Zeile, False
         END IF
      ELSE
         IF INSTR(Zeile, "- ") THEN PrintAktion Zeile, True
      END IF
   LOOP
   CLOSE

   Statistik

REM $STATIC
FUNCTION FindProcName (Zeile AS STRING) AS STRING

   DIM Temp AS STRING
   IF LEFT$(Zeile, 11) = "STATIC SUB " THEN
      Temp = MID$(Zeile, 12)
   ELSEIF LEFT$(Zeile, 16) = "STATIC FUNCTION " THEN
      Temp = MID$(Zeile, 17)
   ELSEIF LEFT$(Zeile, 4) = "SUB " THEN
      Temp = MID$(Zeile, 5)
   ELSEIF LEFT$(Zeile, 9) = "FUNCTION " THEN
      Temp = MID$(Zeile, 10)
   ELSE
      FindProcName = "": EXIT FUNCTION
   END IF
   FindProcName = RTRIM$(LEFT$(Temp, INSTR(Temp + "(", "(") - 1))

END FUNCTION

' Diese Prozedur ist SEHR LANGSAM, weil sie keine Daten in Arrays
' o.. zwischenspeichert, sondern immer die Dateien ffnet und
' durchliest.
' So ist aber die komplizierte Funktionsweise klarer, und wer will,
' kann ja gerne etwas daran feilen...
SUB GetInfo (Overlay AS INTEGER, Adresse AS STRING, Datei AS STRING, ZeileAbs AS INTEGER, Prozedur AS STRING, ZeileRel AS INTEGER, Zeile AS STRING, Correct AS INTEGER)

   DIM Suchen AS STRING, LastName AS STRING
   DIM SegName AS STRING, SourceName AS STRING
   DIM SourceLine AS INTEGER, LetzteZeile AS STRING
   DIM Position AS INTEGER, LineCount AS INTEGER, LocalCount AS INTEGER
   DIM Temp AS STRING

   ' Zunchst wird in der Map-Datei nach dem Abschnitt
   ' gesucht, der mit "Overlay xH" oder "Resident" beginnt.
   OPEN MapFile FOR INPUT AS #2
   IF Overlay THEN
      Suchen = " Overlay " + HEX$(Overlay) + "H"
   ELSE
      Suchen = " Resident"
   END IF
   DO UNTIL EOF(2) OR Zeile = Suchen
      LINE INPUT #2, Zeile
   LOOP
   IF EOF(2) THEN GOTO NichtGefunden

   ' Aus diesem Abschnitt kann jetzt aufgrund der Adresse, die
   ' bergeben wurde, der Segmentname ermittelt werden.
   DO
      LINE INPUT #2, Zeile
      IF LEFT$(Zeile, 3) = " Ov" OR LTRIM$(Zeile) = "" OR MID$(Zeile, 3, 4) > Adresse THEN
         IF LEN(LastName) THEN
            SegName = RTRIM$(LastName)
            EXIT DO
         END IF
      END IF
      LastName = MID$(Zeile, 23, 20)
   LOOP UNTIL EOF(2) OR LEFT$(Zeile, 3) = " Ov" OR LEFT$(Zeile, 4) = "Line"

   IF LEN(SegName) = 0 THEN GOTO NichtGefunden

   ' Nachdem das Segment gefunden ist, wird in der MAP-Datei nach
   ' dem Zeilennummern-Abschnitt fr dieses Segment gesucht.
   ' Hieraus kann sofort der Name des Moduls gewonnen werden:
   DO UNTIL EOF(2)
      LINE INPUT #2, Zeile
      IF LEFT$(Zeile, 4) = "Line" AND INSTR(Zeile, "segment " + SegName) THEN
         SourceName = MID$(Zeile, INSTR(Zeile, "(") + 1)
         SourceName = LEFT$(SourceName, INSTR(SourceName, ")") - 1)
         EXIT DO
      END IF
   LOOP
   IF LEN(SourceName) = 0 THEN GOTO NichtGefunden

   ' Nun wird in diesem Zeilennummernbereich die bergebene
   ' Adresse gesucht. Wird sie gefunden, so steht davor die
   ' Zeilennummer.
   Position = 0
   DO
      LetzteZeile = Zeile: LINE INPUT #2, Zeile
      Position = INSTR(Zeile, ":" + Adresse)
   LOOP UNTIL LEFT$(Zeile, 4) = "Line" OR EOF(2) OR Position
   IF Position = 0 THEN
      ZeileAbs = 0: Datei = SourceName: CLOSE 2: EXIT SUB
   END IF

   IF Correct THEN                 ' Wenn dieser Flag gesetzt ist, wird die Zeile
      Temp = LetzteZeile + Zeile   ' gesucht, die eine Adresse frher liegt
      FOR Position = Position + LEN(LetzteZeile) - 1 TO 1 STEP -1
      IF MID$(Temp, Position, 1) = ":" THEN EXIT FOR
      NEXT
      SourceLine = VAL(MID$(Temp, Position - 10, 6))
   ELSE
      SourceLine = VAL(MID$(Zeile, Position - 11, 6))
   END IF
   CLOSE 2

   ' Jetzt ist die Zeilennummer in der Quelldatei bekannt.
   ' Die Quelldatei wird geffnet, um die Zeile zu lesen.
   OPEN SourceName FOR INPUT AS #2: LineCount = 0
   DO
      LINE INPUT #2, Zeile
      Temp = FindProcName(Zeile)                          ' Ist die gerade gelesen Zeile Anfang einer Prozedur?
      IF LEN(Temp) THEN Prozedur = Temp: LocalCount = 0   ' Wenn ja: Namen merken!
      LineCount = LineCount + 1: LocalCount = LocalCount + 1
   LOOP UNTIL LineCount = SourceLine
   Datei = SourceName: ZeileAbs = SourceLine: ZeileRel = LocalCount
   CLOSE 2
   EXIT SUB

NichtGefunden:
   CLOSE 2
   ZeileAbs = 0: Datei = ""

END SUB

' Langsamer als direkte Addition, aber weniger Schreibarbeit!
SUB INC (Zahl AS LONG)
   Zahl = Zahl + 1
END SUB

FUNCTION OverlayText (Zahl AS INTEGER) AS STRING

   IF Zahl = 0 THEN
      OverlayText = "Root"
   ELSE
      OverlayText = "Overlay" + STR$(Zahl)
   END IF

END FUNCTION

SUB PrintAktion (Zeile AS STRING, Ausgabe AS INTEGER)

   DIM Aktion AS STRING, Overlay AS INTEGER
   STATIC FolgeZeile AS INTEGER

   Aktion = MID$(Zeile, 20, 20): Overlay = VAL("&h" + MID$(Zeile, 49, 4))
   IF Overlay > UBOUND(Count) THEN REDIM PRESERVE Count(1 TO Overlay)  AS CountType

   IF INSTR(Aktion, "Present") THEN
      IF Ausgabe THEN PRINT "   - Keine, da Overlay"; Overlay; "bereits geladen ist."
      INC Count(Overlay).Hit
   ELSEIF INSTR(Aktion, "iscard from h") THEN
      IF FolgeZeile THEN FolgeZeile = False: PRINT "gelscht"
      IF Ausgabe THEN PRINT "   - Overlay"; Overlay; "wird aus dem Heap "; : FolgeZeile = True
      INC Count(Overlay).ToDisk
   ELSEIF INSTR(Aktion, "to extend") THEN
      IF Ausgabe THEN PRINT "in das XMS ausgelagert": FolgeZeile = False
      INC Count(Overlay).ToXMS
   ELSEIF INSTR(Aktion, "to expand") THEN
      IF Ausgabe THEN PRINT "in das EMS ausgelagert": FolgeZeile = False
      INC Count(Overlay).ToEMS
   ELSEIF INSTR(Aktion, "oad from di") THEN
      IF FolgeZeile THEN FolgeZeile = False: PRINT "gelscht"
      IF Ausgabe THEN PRINT "   - Overlay"; Overlay; "wird von der Platte nachgeladen"
      INC Count(Overlay).FromDisk
   ELSEIF INSTR(Aktion, "oad from exp") THEN
      IF FolgeZeile THEN FolgeZeile = False: PRINT "gelscht"
      IF Ausgabe THEN PRINT "   - Overlay"; Overlay; "wird aus dem EMS nachgeladen"
      INC Count(Overlay).FromEMS
   ELSEIF INSTR(Aktion, "oad from ext") THEN
      IF FolgeZeile THEN FolgeZeile = False: PRINT "gelscht"
      IF Ausgabe THEN PRINT "   - Overlay"; Overlay; "wird aus dem XMS nachgeladen"
      INC Count(Overlay).FromXMS
   ELSEIF INSTR(Aktion, "iscard from c") THEN
      IF FolgeZeile THEN FolgeZeile = False: PRINT "gelscht"
      IF Ausgabe THEN PRINT "   - Overlay"; Overlay; "wird aus dem EMS/XMS gelscht"
      INC Count(Overlay).DiscardEMSXMS
   END IF

END SUB

SUB Statistik ()

   DIM i AS INTEGER

   PRINT
   PRINT "Overlay"; TAB(10); "Treffer"; TAB(21); "Laden"; TAB(36); "Lschen aus Heap"; TAB(56); "Lschen aus EMS/XMS"
   FOR i = 1 TO UBOUND(Count)
      PRINT USING "#####"; i;
      PRINT TAB(10); USING "#####"; Count(i).Hit;
      PRINT TAB(20); Count(i).FromDisk + Count(i).FromEMS + Count(i).FromXMS;
      PRINT "("; FORMAT$(Count(i).FromDisk); "+"; FORMAT$(Count(i).FromEMS); "+"; FORMAT$(Count(i).FromXMS); ")";
      PRINT TAB(35);
      PRINT Count(i).ToDisk; "("; FORMAT$(Count(i).ToDisk - Count(i).ToEMS - Count(i).ToXMS);
      PRINT "+"; FORMAT$(Count(i).ToEMS); "+"; FORMAT$(Count(i).ToXMS); ")";
      PRINT TAB(55); Count(i).DiscardEMSXMS
   NEXT
   PRINT
   PRINT "(a+b+c): a ist Anzahl der Platten-, b Anzahl der EMS- und c Anzahl der"
   PRINT "         der XMS-Zugriffe; beim Laden wird angegeben, woher geladen wird,"
   PRINT "         beim Lschen, ob das Overlay in den EMS/XMS ausgelagert wird oder"
   PRINT "         nur noch auf der Platte steht."

END SUB

' Wie LTRIM$, entfernt jedoch auch Tab-Zeichen
FUNCTION XLTRIM (Text AS STRING) AS STRING

   CONST xTab = "	", xSpace = " "
   DIM i AS INTEGER
   i = 1
   DO WHILE (MID$(Text, i, 1) = xTab OR MID$(Text, i, 1) = xSpace) AND i <= LEN(Text)
      i = i + 1
   LOOP
   XLTRIM$ = MID$(Text, i%)

END FUNCTION

